unit main;

(* unit main       v1.0      *)
(* auteur : barrault jrmy  *)
(* date :  31/05/07          *)

(* L'unite main contient la fiche principale du jeu de serpent *)
(* Elle utilise les units serpent et bonus                    *)


interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Menus , Serpent , Bonus, ComCtrls, Score ;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    MNUFichier: TMenuItem;
    MNUNouvelle: TMenuItem;
    Horloge: TTimer;
    MNUQuitter: TMenuItem;
    Option1: TMenuItem;
    MNUdifficulte: TMenuItem;
    MNUDebutant: TMenuItem;
    MNUIntermediaire: TMenuItem;
    MNUExpert: TMenuItem;
    StatusBar1: TStatusBar;
    MNUAide: TMenuItem;
    MNUAPropos: TMenuItem;
    MNUHelp: TMenuItem;
    MNURecord: TMenuItem;
    MNUReset: TMenuItem;
    Shape1: TShape;
    Solitaire1: TMenuItem;
    Contrelamachine1: TMenuItem;
    HorlogeVsOrdinateur: TTimer;
    HorlogeVSJoueur: TTimer;
    procedure HorlogeTimer(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure MNUQuitterClick(Sender: TObject);
    procedure MNUIntermediaireClick(Sender: TObject);
    procedure MNUDebutantClick(Sender: TObject);
    procedure MNUExpertClick(Sender: TObject);
    procedure MNUAProposClick(Sender: TObject);
    procedure MNUHelpClick(Sender: TObject);
    procedure MNUResetClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Solitaire1Click(Sender: TObject);
    procedure Contrelamachine1Click(Sender: TObject);
    procedure HorlogeVsOrdinateurTimer(Sender: TObject);
    procedure HorlogeVSJoueurTimer(Sender: TObject);

  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;


 

var
  Form1: TForm1;
  MonSerpent : TSerpent;
  SonSerpent : TSerpent;
  MonBonus : TBonus;
  MonScore : TScore;


implementation

{$R *.dfm}

procedure TForm1.HorlogeTimer(Sender: TObject);
begin
 if Not MonSerpent.avancer( Form1) then      //si on se mort la queue ou si rencontre mur
 begin
   horloge.Enabled := false;  //on arrete l'horloge : le jeu
   MonSerpent.Detruire;       //efface le serpent
   Monbonus.Detruire;         //efface le bonus
   showmessage('GAME OVER');
   MNUDifficulte.Enabled := true;   //on autorise le changement de difficult

           //StatusBar1.Panels.Items[2].Text :=  'Recordman : '+LeRecordmanSolo;
           //StatusBar1.Panels.Items[1].Text :=  'Record : '+inttostr(LeRecordSolo);

 end
 else    //pas de collision avec mur ou queue
 if MonSerpent.TestBonus(Monbonus) then    //si on rencontre un bonus
 begin
 MonScore.AugmenterJoueur( 10* Monbonus.NumGenre ); //10 point pour les bonus de type 1, 20 type 2 et 30 type 3
 ////StatusBar1.Panels.Items[0].Text := 'Score Actuel : '+inttostr(MonScore);
   repeat
     MonBonus.detruire;      //on efface le bonus mang ou apparu dans le serpent
     Monbonus := TBonus.creer(Form1 , MNUDifficulte.Tag ); //on en remet un nouveau au hasard sur le plateau
   until MonSerpent.TestPresenceSerpent( MonBonus.left , MonBonus.top  ) = false ;
  MonSerpent.grandir;      //on grandit le serpent de 1
 end;

 Horloge.interval := MonSerpent.vitesse ; //au cas ou vitesse change suite a bonus 3

end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin

//on envoie pas Key  changerdedirection pour pouvoir eventuellement changer
//les touches de direction facilement, par exemple  z,q,s,d, 
//ou meme mettre la souris !


if (MonSerpent = nil ) and (key <> VK_CONTROL) then
  exit; // si pas de jeu en cours


case Key of

80 :       begin                         //pause
             if SonSerpent = nil then
             Horloge.Enabled:= Not Horloge.Enabled
             else
             HorlogeVsOrdinateur.Enabled := Not HorlogeVsOrdinateur.Enabled;
             HorlogeVsJoueur.Enabled := Not HorlogeVsJoueur.Enabled;
           end;

VK_LEFT :  begin
             MonSerpent.changerdirection(GAUCHE)
           end;// flche gauche

VK_UP :    begin
             MonSerpent.changerdirection(HAUT)
           end;// flche haut

VK_RIGHT : begin
             MonSerpent.changerdirection(DROITE)
           end;// flche droite

VK_DOWN :  begin
             MonSerpent.changerdirection(BAS)
           end;// flche bas

VK_CONTROL : begin
               Form1.windowstate := wsMinimized;
               Horloge.enabled:=false;      //mode anti patron
               HorlogeVsOrdinateur.Enabled := false;
               HorlogeVsJoueur.Enabled := false;
             end;
end;



end;

procedure TForm1.MNUQuitterClick(Sender: TObject);
begin
Form1.Close;  //fermeture de l'application
end;

procedure TForm1.MNUIntermediaireClick(Sender: TObject);
begin
MNUDifficulte.Tag := 2;
end;

procedure TForm1.MNUDebutantClick(Sender: TObject);
begin
MNUDifficulte.Tag := 1;
end;

procedure TForm1.MNUExpertClick(Sender: TObject);
begin
MNUDifficulte.Tag := 3;
end;

procedure TForm1.MNUAProposClick(Sender: TObject);
begin
   showmessage('JBSoft V1.0'+#13+'Contact '+' jeje_delbarro@hotmail.com');
end;

procedure TForm1.MNUHelpClick(Sender: TObject);
begin
   //message d'aide de prsentation du jeu
   showmessage('JBSoft prsente SNAKE'+#13+
                       #13+'SNAKE est un jeu de serpent classique qui se joue'+
                       #13+' l''aide des touches directionnelles du clavier et'+
                       #13+'ou vous devrez manger des bonus pour pouvoir grandir'+
                       #13+'et marquer des points.'+
                       #13+'La touche p met ou enlve le jeu du mode pause.'+
                       #13+'La touche Ctrl est un mode anti patron qui cache le'+
                       #13+'jeu et le met en mode pause.'+
                       #13+'Plusieurs niveaux sont disponible : '+
                       #13+'  - Le niveau dbutant qui donne accs aux bonus'+
                       #13+'    verts turquoise d''une valeur de 10 points.'+
                       #13+'  - Le niveau intermdiaire qui donne accs aux'+
                        #13+'   bonus bleus foncs d''une valeur de 20 points'+
                       #13+'    et qui fait grandir le serpent deux fois plus vite.'+
                       #13+'  - Le niveau expert qui donne accs aux bonus'+
                       #13+'    violets d''une valeur de 30 points, qui fait'+
                       #13+'    grandir le serpent deux fois plus vite et qui'+
                       #13+'    acclre ce dernier.'+
                       #13+'Pour battre le record vous devrez sans doute passer'+
                       #13+'par ce niveau.'
                        );

end;

procedure TForm1.MNUResetClick(Sender: TObject);
begin

         //  StatusBar1.Panels.Items[2].Text :=  'Recordman : ';
         //  StatusBar1.Panels.Items[1].Text :=  'Record : 0';

end;

procedure TForm1.FormCreate(Sender: TObject);
begin

   //    StatusBar1.Panels.Items[1].Text :=  'Record : '+inttostr(LeRecordSolo);


    //   StatusBar1.Panels.Items[2].Text :=  'Recordman : '+LeRecordmanSolo;


end;

procedure TForm1.Solitaire1Click(Sender: TObject);
var Shape : TShape;
begin
 MNUDifficulte.Enabled := false;          //on autorise pas le changement de difficult en cours de jeu
 if MonSerpent <> nil then MonSerpent.detruire;
 if MonBonus <> nil then MonBonus.detruire;
 if SonSerpent <> nil then SonSerpent.detruire;
 MonSerpent := TSerpent.creer(Form1 , clMoneygreen );   //cration du serpent
 MonBonus := TBonus.creer(Form1 , MNUDifficulte.Tag );      //cration d'un bonus avec la difficult selectionne
 Horloge.interval := MonSerpent.vitesse ;       //actualisation de la vitesse de l'horloge et donc du serpent
 Horloge.Enabled := true;                      //mise en route de l'horloge : le jeu commence
 MonScore.MiseAZeroScores;
 ////StatusBar1.Panels.Items[0].Text := 'Score Actuel : '+inttostr(MonScore);
end;

procedure TForm1.Contrelamachine1Click(Sender: TObject);
var Shape : TShape;
begin
 MNUDifficulte.Enabled := false;          //on n'autorise pas le changement de difficult en cours de jeu
 if MonSerpent <> nil then MonSerpent.detruire;
 if MonBonus <> nil then MonBonus.detruire;
 if SonSerpent <> nil then SonSerpent.detruire;
 SonSerpent := TSerpent.creer( Form1 , clPurple );   //cration du serpent de l'ordinateur
 MonSerpent := TSerpent.creer( Form1 , clMoneygreen );   //cration du serpent
 MonBonus := TBonus.creer(Form1 , MNUDifficulte.Tag );      //cration d'un bonus avec la difficult selectionne
 HorlogeVsOrdinateur.interval := SonSerpent.vitesse ;       //actualisation de la vitesse de l'horloge et donc du serpent
 HorlogeVSJoueur.Interval := MonSerpent.vitesse;
 HorlogeVsOrdinateur.Enabled:=true;
 HorlogeVSJoueur.Enabled := true;                      //mise en route de l'horloge : le jeu commence
 MonScore.MiseAZeroScores;

end;

procedure TForm1.HorlogeVsOrdinateurTimer(Sender: TObject);
begin

 SonSerpent.ChangerdirectionAutomatique(Monbonus);
 
 if ( Not SonSerpent.avancer( Form1) ) or ( MonSerpent.TestPresenceSerpent(SonSerpent.left(0), SonSerpent.top(0) )) then      //si on se mort la queue ou si rencontre mur
 begin
   SonSerpent.Detruire;       //efface le serpent
   SonSerpent := TSerpent.creer( Form1 , clpurple );   //cration du serpent de l'ordinateur
   MonScore.MiseAZeroScoreOrdinateur;
 end
 else    //pas de collision avec mur ou queue
 if SonSerpent.TestBonus(Monbonus) then    //si on rencontre un bonus
 begin
 MonScore.AugmenterOrdinateur( 10* Monbonus.NumGenre );
   repeat
     MonBonus.detruire;      //on efface le bonus mang ou apparu dans le serpent
     Monbonus := TBonus.creer(Form1 , MNUDifficulte.Tag ); //on en remet un nouveau au hasard sur le plateau
   until( SonSerpent.TestPresenceSerpent( MonBonus.left , Monbonus.top  ) = false ) AND   ( MonSerpent.TestPresenceSerpent( MonBonus.left , Monbonus.top   ) = false );
  SonSerpent.grandir;      //on grandit le serpent de 1

 end;

 HorlogeVsOrdinateur.interval := SonSerpent.vitesse ; //au cas ou vitesse change suite a bonus 3

end;



procedure TForm1.HorlogeVSJoueurTimer(Sender: TObject);
begin
 if ( Not MonSerpent.avancer( Form1)) or ( SonSerpent.TestPresenceSerpent(MonSerpent.left(0), MonSerpent.top(0) )) then      //si on se mort la queue ou si rencontre mur
 begin
   MonSerpent.Detruire;       //efface le serpent
   MonSerpent := TSerpent.creer( Form1 , clMoneygreen );  
   MonScore.MiseAZeroScoreJoueur;
 end
 else    //pas de collision avec mur ou queue
 if MonSerpent.TestBonus(Monbonus) then    //si on rencontre un bonus
 begin
 MonScore.AugmenterJoueur(10* Monbonus.NumGenre );
   repeat
     MonBonus.detruire;      //on efface le bonus mang ou apparu dans le serpent
     Monbonus := TBonus.creer(Form1 , MNUDifficulte.Tag ); //on en remet un nouveau au hasard sur le plateau
   until(  MonSerpent.TestPresenceSerpent( MonBonus.left , Monbonus.top  )  = false ) AND ( SonSerpent.TestPresenceSerpent(MonBonus.left , Monbonus.top   ) = false );
  MonSerpent.grandir;      //on grandit le serpent de 1
end;
 HorlogeVsJoueur.interval := MonSerpent.vitesse ; //au cas ou vitesse change suite a bonus 3
end;

end.

